function [allfiltered] = applyfilterfftsameLocalNormMethod2(I, allfilter)
% applyfilterfftsameLocalNormMethod2 - Filter image by a bank of filters with local normalization. 
%
% I: input images
% allfilter: filter bank
% threshold: filter response is set to zero if below threshold

nimage = size(I, 2);    % number of training images
norient = size(allfilter, 2);     % number of orientations
h = (size(allfilter{1}, 1)-1)/2;  % half size of filters
[sx, sy] = size(I{1});  % size of images

allfiltered = cell(nimage, norient);  % filtered images
for i = 1 : nimage
    fftI{i} = fft2(I{i}, sx+h+h, sy+h+h);
end
for o = 1 : norient
   fftf{o} = fft2(allfilter{1, o}, sx+h+h, sy+h+h); 
end

for i = 1 : nimage
   fftIi = fftI{i};
   for o = 1 : norient
       fftfo = fftf{o}; 
       out = ifft2(fftIi.*fftfo); 
       filtered = out(h+1:h+sx, h+1:h+sy); 
       re = real(filtered); im = imag(filtered); 
       energy = re.*re + im.*im;  % compute the local energy
       allfiltered{i, o} = energy / mean(energy(:));
   end
end

mask = ones(sx,sy);
mask([1:h sx-h:sx],:) = 0; mask(:,[1:h sy-h:sy]) = 0;

radius = floor(h*2.5);
aveFilter = ones(2*radius+1,2*radius+1)/((2*radius+1)^2);
for i = 1:nimage
    localMeanMap = zeros(sx,sy);
    for o = 1:norient
        localMeanMap = localMeanMap + 1/norient * imfilter(allfiltered{i, o},aveFilter,'replicate');
    end
    for o = 1:norient
        allfiltered{i,o} = allfiltered{i,o} ./ localMeanMap .* mask .* sigmoidOnOriginalResponse(allfiltered{i,o});
    end
end

%% sigmoid transform
function v = sigmoidOnOriginalResponse(v)
v = 1 ./ ( 1 + exp( 1 * -( v - 3 ) ) );
